searchData={"items":[{"type":"module","title":"Restruct","doc":"Restruct is a library for migrating struct values to conform to their current\ndefinitions.\n\nThis is useful when you have a struct value that was created with an older\nversion of the defining module and you want to update it to match the current\ndefinition.","ref":"Restruct.html"},{"type":"function","title":"Restruct.migrate/2","doc":"Ensure a struct value conforms to its current definition. Any keys that have\nbeen removed from the definition will be removed, and any new keys will be\nadded and initialized to their defined defaults.\n\n**Warning:** There is a potential for data loss when using this function.\nIn addition to dropping values for any keys that have been removed from the\ndefinition, plain maps that use structs for keys may end up with fewer entries\nif any of those keys become equal after having fields removed (the `:keep`\noption can be used to prevent this).","ref":"Restruct.html#migrate/2"},{"type":"function","title":"Options - Restruct.migrate/2","doc":"* `:recursive` - If `true`, the function will recursively migrate structs in\n  nested data structures. Setting this option to false and passing a value\n  other than a struct is a no-op. Defaults to `true`.\n* `:keep` - If `true`, the function will keep extra fields that are not\n  defined in the struct. Defaults to `false`.","ref":"Restruct.html#migrate/2-options"},{"type":"function","title":"Examples - Restruct.migrate/2","doc":"iex> defmodule X do\n    iex>   defstruct foo: nil, bar: 8\n    iex> end\n    iex> value = %{__struct__: X, foo: 1, baz: 2}\n    iex> Restruct.migrate(value)\n    %{__struct__: X, foo: 1, bar: 8}\n    iex> Restruct.migrate(value, keep: true)\n    %{__struct__: X, foo: 1, bar: 8, baz: 2}\n    iex> :code.purge(X)\n    iex> :code.delete(X)","ref":"Restruct.html#migrate/2-examples"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}